Avira.MarketingResearch.Web/Controllers/ServiceController.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Net.Http;
using System.Threading.Tasks;
using Avira.MarketingResearch.LogService;
using Avira.MarketingResearch.Model.ViewModels;
using Avira.MarketingResearch.Web.CustomFilter;
using Avira.MarketingResearch.Web.Models;
using Avira.MarketingResearch.WebApiService;
using Microsoft.AspNetCore.Http;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.Rendering;

namespace Avira.MarketingResearch.Web.Controllers
{
    [NoCache]
    [Authorization]
    public class ServiceController : BaseController
    {
        public readonly IServiceRepository _serviceRepository;
        private ILoggerManager _logger;
        public ServiceController(IServiceRepository serviceRepository, ILoggerManager logger)
        {
            _serviceRepository = serviceRepository;
            _logger = logger;
        }

        public ActionResult Index()
        {
            return View();
        }

        public ActionResult LoadData(ServiceViewModel service)
        {
            var draw = Request.Form["draw"].FirstOrDefault();
            int totalRecords = 0;
            List<ServiceViewModel> data = null;
            try
            {
                var start = Request.Form["start"].FirstOrDefault();
                var length = Request.Form["length"].FirstOrDefault();
                string search = Request.Form["search[value]"];

                var sortColumn = Request.Form["columns[" + Request.Form["order[0][column]"].FirstOrDefault() + "][name]"].FirstOrDefault();
                var sortColumnDir = Request.Form["order[0][dir]"].FirstOrDefault();
                var SortDirection = -1;
                if (sortColumnDir == "asc")
                {
                    SortDirection = 1;
                }
                else
                {
                    SortDirection = -1;
                }

                int skip = start != null ? Convert.ToInt32(start) : 0;
                int pageSize = length.ToString() != null ? Convert.ToInt32(length) : 0;
                int PageStart = start.ToString() != null ? Convert.ToInt32(start) : 0;
                var contollerName = this.ControllerContext.RouteData.Values["controller"].ToString();

                HttpResponseMessage response = _serviceRepository.GetResponse(contollerName, PageStart, pageSize, SortDirection, sortColumn, search);
                response.EnsureSuccessStatusCode();
                List<ServiceViewModel> services = response.Content.ReadAsAsync<List<ServiceViewModel>>().Result;
                ViewBag.Title = "All Services";
                data = services;
          
                foreach (var item in services)
                {
                    totalRecords = item.TotalItems;
                }
            }
            catch (Exception ex)
            {
                _logger.LogError(ex.Message);
            }
            return Json(new { draw = draw, recordsFiltered = totalRecords, recordsTotal = totalRecords, data = data });

        }

        public ActionResult Create()
        {
            var contollerName = this.ControllerContext.RouteData.Values["controller"].ToString();
            HttpResponseMessage response = _serviceRepository.GetAllParentResponse(contollerName);
            List<ServiceViewModel> serviceList = response.Content.ReadAsAsync<List<ServiceViewModel>>().Result;
            ViewBag.ServiceList = new SelectList(serviceList, "Id", "ServiceName");
            return View();
        }

        [HttpPost]
        public IActionResult Create(ServiceInsertDbViewModel service)
        {
            try
            {
                var contollerName = this.ControllerContext.RouteData.Values["controller"].ToString();
                HttpResponseMessage response = _serviceRepository.PostResponse(contollerName, service);
                response.EnsureSuccessStatusCode();
                HttpResponseMessage response1 = _serviceRepository.GetAllParentResponse(contollerName);
                response1.EnsureSuccessStatusCode();
                List<ServiceViewModel> serviceList = response1.Content.ReadAsAsync<List<ServiceViewModel>>().Result;
                ViewBag.ServiceList = new SelectList(serviceList, "Id", "ServiceName", service.ParentServiceId);
                ViewData viewModel = response.Content.ReadAsAsync<ViewData>().Result;
                if (viewModel != null)
                {
                    ViewBag.Message = viewModel.Message;
                }
            }
            catch(Exception ex)
            {
                _logger.LogError(ex.Message);
            }
            //return RedirectToAction("Index");
            return View(service);
        }

        [HttpGet]
        public IActionResult Edit(string id)
        {
            try
            {
                var contollerName = this.ControllerContext.RouteData.Values["controller"].ToString();
                HttpResponseMessage response = _serviceRepository.GetByIdResponse(contollerName, id);
                response.EnsureSuccessStatusCode();
                HttpResponseMessage response1 = _serviceRepository.GetAllParentResponse(contollerName);
                ServiceUpdateDbViewModel service = response.Content.ReadAsAsync<ServiceUpdateDbViewModel>().Result;
                response1.EnsureSuccessStatusCode();
                List<ServiceViewModel> serviceList = response1.Content.ReadAsAsync<List<ServiceViewModel>>().Result;
                ViewBag.ServiceList = new SelectList(serviceList, "Id", "ServiceName", service.ParentServiceId);
                return View(service);
            }
            catch (Exception ex)
            {
                _logger.LogError(ex.Message);
                ErrorViewModel err = new ErrorViewModel { RequestId = "1234" };
                //Log the exception 
                return View("Error", err);
            }
        }

        [HttpPost]
        public IActionResult Edit(ServiceUpdateDbViewModel service)
        {
            try
            {
                var contollerName = this.ControllerContext.RouteData.Values["controller"].ToString();
                HttpResponseMessage response = _serviceRepository.PutResponse(contollerName, service);
                response.EnsureSuccessStatusCode();
                HttpResponseMessage response1 = _serviceRepository.GetAllParentResponse(contollerName);
                response1.EnsureSuccessStatusCode();
                List<ServiceViewModel> serviceList = response1.Content.ReadAsAsync<List<ServiceViewModel>>().Result;
                ViewBag.ServiceList = new SelectList(serviceList, "Id", "ServiceName", service.ParentServiceId);
                ViewData viewModel = response.Content.ReadAsAsync<ViewData>().Result;
                if (viewModel != null)
                {
                    ViewBag.Message = viewModel.Message;
                }
            }
            catch (Exception ex)
            {
                _logger.LogError(ex.Message);
            }
            //return RedirectToAction("Index");
            return View(service);
        }

        [HttpGet]
        public IActionResult Delete(string id)
        {
            try
            {
                var contollerName = this.ControllerContext.RouteData.Values["controller"].ToString();
                HttpResponseMessage response = _serviceRepository.GetByIdResponse(contollerName, id);
                response.EnsureSuccessStatusCode();
                ServiceUpdateDbViewModel service = response.Content.ReadAsAsync<ServiceUpdateDbViewModel>().Result;
                if (service.ParentServiceId.HasValue)
                {
                    HttpResponseMessage response1 = _serviceRepository.GetByIdResponse(contollerName, service.ParentServiceId.ToString());
                    response1.EnsureSuccessStatusCode();
                    ServiceViewModel parentService = response1.Content.ReadAsAsync<ServiceViewModel>().Result;
                    ViewBag.ParentName = parentService.ServiceName;
                }
                else
                {
                    ViewBag.ParentName = String.Empty;
                }
                return View(service);
            }
            catch (Exception ex)
            {
                _logger.LogError(ex.Message);
                ErrorViewModel err = new ErrorViewModel { RequestId = "1234" };
                //Log the exception 
                return View("Error", err);
            }
        }

        [HttpPost]
        public IActionResult Delete(ServiceUpdateDbViewModel service)
        {
            try
            {
                var contollerName = this.ControllerContext.RouteData.Values["controller"].ToString();
                HttpResponseMessage response = _serviceRepository.DeleteResponse(contollerName, service);
                response.EnsureSuccessStatusCode();
                ViewData viewModel = response.Content.ReadAsAsync<ViewData>().Result;
                if (viewModel != null)
                {
                    ViewBag.Message = viewModel.Message;
                }
            }
            catch (Exception ex)
            {
                _logger.LogError(ex.Message);
            }
            return RedirectToAction("Index");
        }
    }
}

Avira.MarketingResearch.Web/Views/Service/Create.cshtml
@model Avira.MarketingResearch.Model.ViewModels.ServiceInsertDbViewModel

@{
    ViewBag.Title = "Add Service";
    Layout = "~/Views/Shared/_Layout.cshtml";
}
<link href="~/assets/css/avira-custom.css" rel="stylesheet" />
<script src="~/assets/plugins/jquery/jquery-3.3.1.min.js"></script>
<script src="~/assets/js/page-table-manage.demo.min.js"></script>
<script src="~/ckeditor/ckeditor.js"></script>
<div id="content" class="content">
    <h4>Create Service</h4>
    @if (ViewBag.Message != null)
    {
        <div class="alert alert-success alert-bordered show m-b-10">
            <strong>Info!</strong>
            @ViewBag.Message
            <span class="close" data-dismiss="alert">×</span>
        </div>
    }
    <div class="section-container section-with-top-border">
        @using (Html.BeginForm("Create", "Service", FormMethod.Post))
        {
            @Html.AntiForgeryToken()

            <div class="form-horizontal">

                @Html.ValidationSummary(true, "", new { @class = "text-danger" })
                @Html.HiddenFor(model => model.Id)

                <div class="form-group">
                    @Html.LabelFor(model => model.ServiceName, "Service Name", htmlAttributes: new { @class = "col-md-2" })
                    <div class="col-md-7">
                        @Html.EditorFor(model => model.ServiceName, new { htmlAttributes = new { @class = "form-control" } })
                        @Html.ValidationMessageFor(model => model.ServiceName, "", new { @class = "text-danger" })
                    </div>
                </div>

                <div class="form-group">
                    @Html.LabelFor(model => model.Description, htmlAttributes: new { @class = "col-md-2" })
                    <div class="col-md-7">
                        @Html.TextAreaFor(model => model.Description, htmlAttributes: new { @class = "form-control" })
                        @Html.ValidationMessageFor(model => model.Description, "", new { @class = "text-danger" })
                        <script>
                            CKEDITOR.replace('Description', {
                                height: 40,
                                // Define the toolbar groups as it is a more accessible solution.
                                toolbarGroups: [{
                                    "name": "basicstyles",
                                    "groups": ["basicstyles"]
                                },
                                {
                                    "name": "links",
                                    "groups": ["links"]
                                },
                                {
                                    "name": "paragraph",
                                    "groups": ["list", "blocks"]
                                },
                                {
                                    "name": "document",
                                    "groups": ["mode"]
                                },
                                {
                                    "name": "insert",
                                    "groups": ["insert"]
                                },
                                {
                                    "name": "styles",
                                    "groups": ["styles"]
                                },
                                {
                                    "name": "about",
                                    "groups": ["about"]
                                }
                                ],
                                // Remove the redundant buttons from toolbar groups defined above.
                                removeButtons: 'Underline,Strike,Subscript,Superscript,Anchor,Styles,Specialchar'
                            });
                        </script>
                    </div>
                </div>
                <div class="form-group">
                    @Html.Label("ParentService", "Parent Service", htmlAttributes: new { @class = "col-md-2" })
                    <div class="col-md-5">
                        @Html.DropDownListFor(Model => Model.ParentServiceId, (SelectList)(ViewBag.ServiceList), "Please select", htmlAttributes: new { @class = "form-control" })
                    </div>
                </div>
                <div class="form-group">
                    <div class="col-md-2"></div>
                    <div class="col-md-offset-5 p-l-15">
                        <input type="submit" value="Save" class="btn btn-grey btn-rounded m-b-5 width-100" />
                        <a href="~/Service/Index" class="btn btn-inverse btn-rounded m-b-5 width-100">Back to List </a>
                    </div>
                </div>
            </div>

        }


    </div>
</div>

Avira.MarketingResearch.Web/Views/Service/Delete.cshtml
@model Avira.MarketingResearch.Model.ViewModels.ServiceUpdateDbViewModel

@{
    ViewBag.Title = "Delete Service";
    Layout = "~/Views/Shared/_Layout.cshtml";
}
<link href="~/assets/css/avira-custom.css" rel="stylesheet" />
<script src="~/assets/plugins/jquery/jquery-3.3.1.min.js"></script>
<script src="~/assets/js/page-table-manage.demo.min.js"></script>
<div id="content" class="content">
    <h4>Delete Service</h4>
    @if (ViewBag.Message != null)
    {
        <div class="alert alert-success alert-bordered show m-b-10">
            <strong>Info!</strong>
            @ViewBag.Message
            <span class="close" data-dismiss="alert">×</span>
        </div>
    }
    <div class="section-container section-with-top-border">
        @using (Html.BeginForm("Delete", "Service", FormMethod.Post))
        {
            @Html.AntiForgeryToken()

        <div class="form-horizontal">

            @Html.ValidationSummary(true, "", new { @class = "text-danger" })
            @Html.HiddenFor(model => model.Id)

       
            <div class="alert alert-warning show m-b-10">
                <strong>Warning!</strong>
                Are you sure want to delete this Service?
                <span class="close" data-dismiss="alert">×</span>
            </div>
            <div class="form-group">
                @Html.LabelFor(model => model.ServiceName, "Service Name", htmlAttributes: new { @class = "col-md-2" })
                <div class="col-md-5">
                    @Html.EditorFor(model => model.ServiceName, new { htmlAttributes = new { @class = "form-control", @readonly = "readonly" } })

                </div>
            </div>

            <div class="form-group">
                @Html.LabelFor(model => model.Description, htmlAttributes: new { @class = "col-md-2" })
                <div class="col-md-5">
                    @Html.EditorFor(model => model.Description, new { htmlAttributes = new { @class = "form-control", @readonly = "readonly" } })

                </div>
            </div>

            <div class="form-group">
                @Html.Label("ParentService", "Parent Service", htmlAttributes: new { @class = "col-md-2" })
                <div class="col-md-5">
                    @Html.Label(ViewBag.ParentName, ViewBag.ParentName, htmlAttributes: new { @class = "form-control", @readonly = "readonly" })
                </div>


            </div>

            <div class="form-group">
                <div class="col-md-2"></div>
                <div class="col-md-offset-5 p-l-15">
                    <input type="submit" value="Delete" class="btn btn-rounded btn-grey m-b-5 width-100" />
                    <a href="~/Service/Index" class="btn btn-rounded btn-inverse m-b-5 width-100">Back to List </a>
                </div>
            </div>
        </div>

        }
        <div id="footer" class="footer">
            <span class="pull-right">
                <a href="javascript:;" class="btn-scroll-to-top" data-click="scroll-top">
                    <i class="fa fa-arrow-up"></i> <span class="hidden-xs">Back to Top</span>
                </a>
            </span>
            &copy; 2018 <b>Source Admin</b> All Right Reserved
        </div>
    </div>
</div>

Avira.MarketingResearch.Web/Views/Service/Edit.cshtml
@model Avira.MarketingResearch.Model.ViewModels.ServiceUpdateDbViewModel

@{
    ViewBag.Title = "Edit Service";
}

<link href="~/assets/css/avira-custom.css" rel="stylesheet" />
<script src="~/assets/plugins/jquery/jquery-3.3.1.min.js"></script>
<script src="~/assets/js/page-table-manage.demo.min.js"></script>
<script src="~/ckeditor/ckeditor.js"></script>
<div id="content" class="content">
    <h2>
        Edit Service
    </h2>
    @if (ViewBag.Message != null)
    {
        <div class="alert alert-success alert-bordered show m-b-10">
            <strong>Info!</strong>
            @ViewBag.Message
            <span class="close" data-dismiss="alert">×</span>
        </div>
    }
    <div class="section-container section-with-top-border">

        @using (Html.BeginForm("Edit", "Service", FormMethod.Post))
        {
            @Html.AntiForgeryToken()

            <div class="form-horizontal">


                @Html.ValidationSummary(true, "", new { @class = "text-danger" })
                @Html.HiddenFor(model => model.Id)

                <div class="form-group">
                    @Html.LabelFor(model => model.ServiceName, htmlAttributes: new { @class = "col-md-2" })
                    <div class="col-md-7">
                        @Html.EditorFor(model => model.ServiceName, "Service Name", new { htmlAttributes = new { @class = "form-control" } })
                        @Html.ValidationMessageFor(model => model.ServiceName, "", new { @class = "text-danger" })
                    </div>
                </div>

                <div class="form-group">
                    @Html.LabelFor(model => model.Description, htmlAttributes: new { @class = "col-md-2" })
                    <div class="col-md-7">
                        @Html.TextAreaFor(model => model.Description, htmlAttributes: new { @class = "form-control" })
                        @Html.ValidationMessageFor(model => model.Description, "", new { @class = "text-danger" })
                        <script>
                            CKEDITOR.replace('Description', {
                                height: 40,
                                // Define the toolbar groups as it is a more accessible solution.
                                toolbarGroups: [{
                                    "name": "basicstyles",
                                    "groups": ["basicstyles"]
                                },
                                {
                                    "name": "links",
                                    "groups": ["links"]
                                },
                                {
                                    "name": "paragraph",
                                    "groups": ["list", "blocks"]
                                },
                                {
                                    "name": "document",
                                    "groups": ["mode"]
                                },
                                {
                                    "name": "insert",
                                    "groups": ["insert"]
                                },
                                {
                                    "name": "styles",
                                    "groups": ["styles"]
                                },
                                {
                                    "name": "about",
                                    "groups": ["about"]
                                }
                                ],
                                // Remove the redundant buttons from toolbar groups defined above.
                                removeButtons: 'Underline,Strike,Subscript,Superscript,Anchor,Styles,Specialchar'
                            });
                        </script>
                    </div>


                </div>

                <div class="form-group">
                    @Html.Label("ParentService", "Parent Service", htmlAttributes: new { @class = "col-md-2" })
                    <div class="col-md-5">
                        @Html.DropDownListFor(Model => Model.ParentServiceId, (SelectList)(ViewBag.ServiceList), "Please select", htmlAttributes: new { @class = "form-control" })
                    </div>


                </div>

                <div class="form-group">
                    <div class="col-md-2"></div>
                    <div class="col-md-offset-5 p-l-15">
                        <input type="submit" value="Save" class="btn btn-rounded btn-grey m-b-5 width-100" />
                        <a href="~/Service/Index" class="btn btn-rounded btn-inverse m-b-5 width-100">Back to List </a>
                    </div>
                </div>
            </div>

        }
    </div> <div id="footer" class="footer">
        <span class="pull-right">
            <a href="javascript:;" class="btn-scroll-to-top" data-click="scroll-top">
                <i class="fa fa-arrow-up"></i> <span class="hidden-xs">Back to Top</span>
            </a>
        </span>
        &copy; 2018 <b>Source Admin</b> All Right Reserved
    </div>
</div>

Avira.MarketingResearch.Web/Views/Service/Index.cshtml
@{
    ViewBag.Title = "All Service";
    Layout = "~/Views/Shared/_Layout.cshtml";
}
<link href="~/assets/css/avira-custom.css" rel="stylesheet" />
<script src="~/assets/plugins/jquery/jquery-3.3.1.min.js"></script>
<script src="~/assets/js/page-table-manage.demo.min.js"></script>

<div id="content" class="content">
    <div class="section-with-top-border">
        <div class="row">
            <div class="col-md-4">
                <h4>Service Segment</h4>
            </div>
            <div class="col-md-8 text-right" style="padding-right:35px" ;>
                <a href="~/Service/Create" class="btn btn-sm btn-inverse width-200">Add New Service</a>
            </div>

        </div>
            <!-- begin panel -->
            <div class="panel pagination-inverse m-b-0 clearfix">

                <table id="data-table" data-order='[[0,"asc"]]' class="table table-bordered table-hover">
                    <thead>
                        <tr class="inverse">
                            <th>Service Name</th>
                            <th>Description</th>
                            <th>Parent Service</th>
                            <th style="pointer-events: none !important;">Actions</th>
                        </tr>
                    </thead>
                    <tbody></tbody>
                </table>
            </div>
            <!-- end panel -->
        </div>

        <div id="footer" class="footer">
            <span class="pull-right">
                <a href="javascript:;" class="btn-scroll-to-top" data-click="scroll-top">
                    <i class="fa fa-arrow-up"></i> <span class="hidden-xs">Back to Top</span>
                </a>
            </span>
            &copy; 2018 <b>Source Admin</b> All Right Reserved
        </div>
        <!-- end #footer -->
    </div>

    <script>
        $(document).ready(function () {
            $("#data-table").DataTable({
                "processing": true, 
                "serverSide": true, 
                "filter": true, 
                "orderMulti": false, 
                "ajax": {
                    "url": "/Service/LoadData",
                    "type": "POST",
                    "datatype": "json",
                },

                "columns": [
                    { "data": "serviceName", "name": "serviceName" },
                    { "data": "description", "name": "description" },
                    { "data": "parentServiceName", "name": "parentServiceName" },
                    {
                        render: function (data, type, full, meta) { return '<a class="btn btn-default btn-xs btn-rounded p-l-10 p-r-10" title="Edit" href="/Service/Edit/' + full.id + '"><i class="fas fa-edit"></i></a> <a class="btn btn-default btn-xs btn-rounded p-l-10 p-r-10" title="Delete" href="/Service/Delete/' + full.id + '"><i class="far fa-trash-alt"></i></a>'; }
                    },
                ]
            });
        });
    </script>